> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cdp.coinbase.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Onchain Wallet Balances

> Query balances for a specific onchain wallet.



## OpenAPI

````yaml GET  /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/web3_balances
openapi: 3.0.1
info:
  title: REST API
  description: >-
    The Coinbase Prime REST API provides programmatic access to trading,
    custody, staking, market data, and account management functionality.
  version: '0.1'
servers:
  - url: https://api.prime.coinbase.com/
security: []
tags:
  - name: PrimeRESTAPI
paths:
  /v1/portfolios/{portfolio_id}/wallets/{wallet_id}/web3_balances:
    get:
      tags:
        - Balances
      summary: List Onchain Wallet Balances
      description: Query balances for a specific onchain wallet.
      operationId: PrimeRESTAPI_ListWeb3WalletBalances
      parameters:
        - name: portfolio_id
          in: path
          description: Portfolio to retrieve balances for.
          required: true
          schema:
            type: string
        - name: wallet_id
          in: path
          description: Onchain wallet to retrieve balances for.
          required: true
          schema:
            type: string
        - name: visibility_statuses
          in: query
          description: >-
            Visibility statuses to filter balances on. Leaving this field empty
            will return only VISIBLE balances.

             - UNKNOWN_VISIBILITY_STATUS: nil
             - VISIBLE: Visible
             - HIDDEN: Hidden
             - SPAM: Spam
          style: form
          explode: true
          schema:
            type: array
            items:
              type: string
              enum:
                - VISIBLE
                - HIDDEN
                - SPAM
        - name: cursor
          in: query
          description: Id to retrieve additional results strictly after
          schema:
            type: string
        - name: limit
          in: query
          description: Number of items to retrieve. Defaults to 100 with a max size of 500.
          schema:
            type: integer
            format: int32
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/coinbase.public_rest_api.ListWeb3WalletBalancesResponse
components:
  schemas:
    coinbase.public_rest_api.ListWeb3WalletBalancesResponse:
      type: object
      properties:
        balances:
          title: List of balances in the onchain wallet
          type: array
          items:
            $ref: '#/components/schemas/coinbase.public_rest_api.Web3Balance'
        pagination:
          $ref: '#/components/schemas/coinbase.public_rest_api.PaginatedResponse'
        defi_balances:
          type: array
          description: >-
            DeFi balances only return for the initial request. No pagination
            support.
          items:
            $ref: '#/components/schemas/coinbase.public_rest_api.DefiBalance'
    coinbase.public_rest_api.Web3Balance:
      type: object
      properties:
        asset:
          $ref: '#/components/schemas/coinbase.public_rest_api.Web3Asset'
        amount:
          type: string
          description: The total amount in whole units with full precision.
          example: '109.42'
        visibility_status:
          $ref: '#/components/schemas/coinbase.public_rest_api.VisibilityStatus'
    coinbase.public_rest_api.PaginatedResponse:
      required:
        - has_next
        - next_cursor
        - sort_direction
      type: object
      properties:
        next_cursor:
          type: string
          description: Cursor to navigate to next page
        sort_direction:
          $ref: '#/components/schemas/coinbase.public_rest_api.SortDirection'
        has_next:
          type: boolean
          description: >-
            A boolean value indicating whether there are more items to paginate
            through
    coinbase.public_rest_api.DefiBalance:
      type: object
      properties:
        network:
          title: Network this asset is on (ie "ethereum-mainnet")
          type: string
        protocol:
          title: >-
            a set of rules and standards that define how data is exchanged (ie
            "Aave V4 ")
          type: string
        net_usd_value:
          title: Total USD value
          type: string
    coinbase.public_rest_api.Web3Asset:
      type: object
      properties:
        network:
          title: Network this asset is on (ie "ethereum-mainnet")
          type: string
        contract_address:
          type: string
          description: Contract Address of this asset (empty for native assets).
        symbol:
          type: string
          description: Symbol of this asset.
        token_id:
          type: string
          description: Token ID of this asset (empty for non  NFT assets).
        name:
          type: string
          description: >-
            Name of this asset, either the name of the crypto token or the NFT
            collection name.
    coinbase.public_rest_api.VisibilityStatus:
      title: |-
        - UNKNOWN_VISIBILITY_STATUS: nil
         - VISIBLE: Visible
         - HIDDEN: Hidden
         - SPAM: Spam
      type: string
      enum:
        - VISIBLE
        - HIDDEN
        - SPAM
    coinbase.public_rest_api.SortDirection:
      type: string
      default: DESC
      enum:
        - DESC
        - ASC

````